import {
  ValidateBy,
  ValidationArguments,
  ValidationOptions,
  buildMessage,
} from 'class-validator';

export function hasProperPassengerSeats(value: any, args: ValidationArguments) {
  if (value === true && typeof args.object['seatsPassenger'] === 'number')
    return args.object['seatsPassenger'] > 0;
  else if (
    (value === false || value === null || value === undefined) &&
    (args.object['seatsPassenger'] === 0 ||
      args.object['seatsPassenger'] === null ||
      args.object['seatsPassenger'] === undefined)
  )
    return true;
  else return false;
}
/* istanbul ignore next */
export function HasProperPassengerSeats(
  validationOptions?: ValidationOptions,
): PropertyDecorator {
  return ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (value, args: ValidationArguments): boolean =>
          hasProperPassengerSeats(value, args),
        defaultMessage: buildMessage(
          () => `passenger and passenger seats are not correct`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
}
