import { CreateAdRequest } from '../dtos/create-ad.request';

import { Frequency } from '../types/frequency.enum';

export class ReccurentNormaliser {
  fromDateResolver(createAdRequest: CreateAdRequest): Date {
    if (createAdRequest.frequency === Frequency.PUNCTUAL)
      return createAdRequest.departure;
    return createAdRequest.fromDate;
  }
  toDateResolver(createAdRequest: CreateAdRequest): Date {
    if (createAdRequest.frequency === Frequency.PUNCTUAL)
      return createAdRequest.departure;
    return createAdRequest.toDate;
  }
  scheduleSunResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 0
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.sun;
  }
  scheduleMonResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 1
    ) {
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    }

    return createAdRequest.schedule.mon;
  }
  scheduleTueResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 2
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.tue;
  }
  scheduleWedResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 3
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.wed;
  }
  scheduleThuResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 4
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.thu;
  }
  scheduleFriResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 5
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.fri;
  }
  scheduleSatResolver(createAdRequest: CreateAdRequest): string {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departure.getDay() === 6
    )
      return `${('0' + createAdRequest.departure.getHours()).slice(-2)}:${(
        '0' + createAdRequest.departure.getMinutes()
      ).slice(-2)}`;
    return createAdRequest.schedule.sat;
  }
}
